### 10.1.0
* Added capture of more specific XMLHttpRequest failure codes
* Added network response capture for synchronous XMLHttpRequests

### 10.0.0
* Introduced new CDN and service endpoints. A new Content Security Policy is
  available at https://docs.logrocket.com/docs/troubleshooting-sessions#section-due-to-content-security-policy

### 9.0.2
* include second argument passed to console.error() in associated exceptions when first argument is 'ERROR'

### 9.0.1
* Allowing "null" property values in `LogRocket.track() calls.

### 9.0.0
* Introduced new CDN and service endpoints. A new Content Security Policy is
  available at https://docs.logrocket.com/docs/troubleshooting-sessions#section-due-to-content-security-policy

### 8.1.3
* Fixed a minor issue that could prevent capture of `history.pushState` and `history.popState` as navigation events.

### 8.1.2
* Added logging to capture stack traces from unhandled rejections that contain errors.

### 8.1.1
* Resolved an issue with environments that make console methods read-only. We will not be able to capture automatic logs in these environments, but will be able to initialize completely.
* When network capture has been explicitly disabled (with the `network.isEnabled: false` initialization option) we will no longer wrap `XMLHttpRequest` or `fetch`.
* Added `dom.disableWebAnimations` initialization option to disable web animation capture, which is enabled by default (https://docs.logrocket.com/reference/disabling-web-animation-api-capture).

### 8.1.0
* Added `trackScrollEvent` SDK call for manually logging element scroll positions.

### 8.0.1
* Fixed an issue where some event listeners could not be removed after SDK shutdown.

### 8.0.0
* Introduced new CDN and service endpoints. A new Content Security Policy is
  available at https://docs.logrocket.com/docs/troubleshooting-sessions#section-due-to-content-security-policy

### 7.0.0
* Introduced new CDN and service endpoints. A new Content Security Policy is
  available at https://docs.logrocket.com/docs/troubleshooting-sessions#section-due-to-content-security-policy

### 6.0.2
* If a network response contains `text/event-stream` content do not attempt to read the body. A placeholder body
  indicating we did not attempt to read the payload is used instead.

### 6.0.1
* Update type definitions to correctly expose `serverURL` for the `LogRocket.init` method.
* Added type definition for the `logrocket/setup` method of configuring the SDK.

### 6.0.0
* Introduced new CDN and service endpoints. A new Content Security Policy is
  available at https://docs.logrocket.com/docs/troubleshooting-sessions#section-due-to-content-security-policy

### 5.0.1
* Added "hiddenAttributes" config option to ignore specific DOM attributes in recording

### 5.0.0
* Introduced new CDN and service endpoints. A new Content Security Policy is
  available at https://docs.logrocket.com/docs/troubleshooting-sessions#section-due-to-content-security-policy

### 4.0.4
* Added new option "privateClassNameBlocklist" to the "dom" init config for css class based redaction.

### 4.0.3
* Fixed bundle size

### 4.0.2
* Added support for Ionic Framework

### 4.0.1
* Added "disableBusyFramesTracker" to allow disabling CPU Usage monitoring

### 4.0.0
* Introduced new CDN and service endpoints. A new Content Security Policy is
  available at https://docs.logrocket.com/docs/troubleshooting-sessions#section-due-to-content-security-policy

### 3.0.1
* Stability improvements
### 3.0.0
* Introduced new CDN and service endpoints. A new Content Security Policy is
  available at https://docs.logrocket.com/docs/troubleshooting-sessions#section-due-to-content-security-policy

### 2.2.1
* Added new option "privateAttributeBlocklist" to the "dom" init config with

### 2.2.0
* Stability improvements

### 2.1.3
* Add TS type for SDK `version` property

### 2.1.2
* Suppress AbortError for completed fetch responses

### 2.1.1
* Stability improvements

### 2.1.0
* Added TS types for cross-domain iframe recording configuration variables
  found here https://docs.logrocket.com/reference#mergeiframes

### 2.0.0
* Introduced new CDN and service endpoints. A new Content Security Policy is
  available at https://docs.logrocket.com/docs/troubleshooting-sessions#section-due-to-content-security-policy

### 1.3.0
* Made NPS survey LogRocket session URL injection optional

### 1.2.3
* Fixed `TrackEventProperties` typescript definition.

### 1.2.2
* Stability improvements

### 1.2.1
* Stability improvements

### 1.2.0
* Delighted Integration

### 1.1.0
* Track API improvements

### 1.0.16
* Wootric integration improvements

### 1.0.15
* Wootric integration

### 1.0.14
* Support non-extensible event listeners

### 1.0.13
* Ignore network request and response bodies when the SDK is shut down.

### 1.0.12
* Added request ID to request and response sanitizers

### 1.0.11
* Stability improvements.

### 1.0.10
* Stability improvements.

### 1.0.9
* Updated TypeScript definition file

### 1.0.8
* Updated TypeScript definition file

### 1.0.7
* Updated TypeScript definition file

### 1.0.6
* Fixed Typescript types for request/response sanitizer and state/action sanitizer options

### 1.0.5
* More improvements to fetch handling in Safari.

### 1.0.4
* Fixed a bug where recording some fetch requests in Safari would fail.

### 1.0.3
* Added OSS attributions to be a good open-source citizen.

### 1.0.2
* Updated TypeScript definition file

### 1.0.1
* Added a warning when the async script is blocked by the browser.

### 1.0.0
* Introduced new CDN and service endpoints. A new Content Security Policy is
  available at https://docs.logrocket.com/docs/troubleshooting-sessions#section-due-to-content-security-policy

### 0.6.21
* Additional error handling when recording network.

### 0.6.20
* Updated TypeScript definition file.

### 0.6.19
* Resolved an issue with server-side rendering tools introduced by the 0.6.18 release.

### 0.6.18
**This release has been revoked due to a bug with server-side applications**

* Added new entrypoint `logrocket/setup` for configuring on-prem SDK.

    // Loads the full SDK from your host instead of our public CDN and
    // configures the SDK to send data to your installation.
    const LogRocket = require('logrocket/setup')({
      sdkServer: 'YOUR_DASHBOARD_HOST',
      ingestServer: 'YOUR_INGEST_HOST',
    });

### 0.6.17
* Added a new option `ingestServer` to simplify configuration for on-prem installs.

### 0.6.16
* Added anonymous use of `identify` to the TypeScript definition file.

### 0.6.15
* Fixed a build issue resulting in a potential reference error.

### 0.6.14
* Fixed minification bug

### 0.6.13
* Updated TypeScript definition file.

### 0.6.12
* Fixed a memory leak when recording XMLHttpRequests.

### 0.6.11
* Fixed a bug where recording some fetch requests in Safari 11.1 would fail.

### 0.6.10
* Fixed `captureException` type definition.

### 0.6.9
* Allow calling `captureException` and `captureMessage` in Node.js environments.

### 0.6.8
* Calling `init` more than once no longer throws an error. The session will not be changed.
* The `startNewSession` method now prints a `console.error` when its called before `init`.

### 0.6.7
* Fixed module export in definition file

### 0.6.6
* Typescript definition file now works with `noImplicitAny` and `strictLibCheck`.

### 0.6.5
* Fixed Typescript definition file

### 0.6.4

* Stability improvements

### 0.6.3

* Fix an edge case where network logging would fail on old iOS Safari.

### 0.6.2

* Stability improvements

### 0.6.1

* Remove some cruft from the SDK

### 0.6.0

* Expose additional methods for logging

### 0.5.5

##### Changes

* Fix a case where MutationObserver was overwritten by user-land code.

### 0.5.4

##### Changes

* Make sure LogRocket doesn't fail to load in NodeJS environment
* Improve timekeeping in browsers with incorrect clocks

### 0.5.3

##### Changes

* Add sessionURL to types.
* Fixed reduxMiddleware type
* Fixed Typescript module definition

### 0.5.2

##### Changes

* Fix `instanceof` checks on `XMLHttpRequest`.
* Added TypeScript definition file.

### 0.5.1

##### Changes

* Switch to an unminified bundle to fix builds for old Webpack versions.

### 0.5.0

##### Features

* Add `LogRocket.track()` for custom analytics events: https://docs.logrocket.com/v1.0/reference#track

### 0.4.3

##### Bugfixes

* Correctly truncate network data for large XHR requests.

### 0.4.2

##### Bugfixes

* Correctly forward XMLHttpRequest.UNSENT, XMLHttpRequest.OPENED, XMLHttpRequest.HEADERS_RECEIVED, XMLHttpRequest.LOADING, and XMLHttpRequest.DONE.

### 0.4.1

##### Changes

* console and network shims are on installed if `LogRocket.init()` is called, instead of when
`LogRocket` is imported. This should make it easier to only install LogRocket in a staging/prod
environment.
* `whatwg-fetch` is no longer included automatically. Make sure to import `whatwg-fetch` before calling `LogRocket.init()`.
* Decreased gzipped bundle size from ~22kb to ~8kb!
