import type LR from './dist/types';

declare function setup(options?: {
  /**
   * Convenience option for configuring both the sdkServer and ingestServer to the same server.
   * Include the protocol (eg. https://lr.example.com)
   */
  enterpriseServer?: string,

  /**
   * Convenience option for configuring where the full SDK should be loaded from for on-prem installs
   * Include the protocol (eg. https://cdn.example.com)
   */
  sdkServer?: string,

  /**
   * Convenience option for configuring the SDK for an on-prem install.
   * Include the protocol (eg. https://ingest.example.com)
   */
  ingestServer?: string,
}): typeof LR;

export = setup;
